/*
 * Copyright 2003 VIA Technologies, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * VIA AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/*************************************************************************
** File libSavageXvMC.c
**
** Authors:
**	John Zhao <jzhao@s3graphics.com>
**
**
***************************************************************************/
/* $XFree86: xc/lib/XvMC/hw/savage/savageXvMC.c,v 1.7 2001/12/18 04:23:55 dawes Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>
#include <math.h>
#include <sys/time.h>

#include <sys/ioctl.h>
#include <Xlibint.h>
#include <fourcc.h>
#include <Xv.h>
#include <Xvlib.h>
#include <XvMC.h>
#include <XvMClib.h>
#include "savageXvMC.h"
#include "s3data.h"


#define MACROCMD  1
#define MS1	  1
#define EXT_MISC_CTRL2 0x67

extern int ioperm(unsigned long, unsigned long, int);
extern int iopl(int);

#define MAXLOOP	   0xffffff
#define MAXFIFO	   0x7f00

#define VGAIN8(x) (*(volatile unsigned char *)((unsigned int)pSavageXvMCContext->MMIO.address + 0x8000 + x))
#define VGAIN16(x) (*(volatile unsigned short *)((unsigned int)pSavageXvMCContext->MMIO.address + 0x8000 + x))

#define VGAOUT16(x, y)	*(volatile unsigned short *)((unsigned int)pSavageXvMCContext->MMIO.address + 0x8000 + x) = y
#define VGAOUT8(x, y)  *(volatile unsigned char *)((unsigned int)pSavageXvMCContext->MMIO.address + 0x8000 + x) = y
#define OUTREG(x, y)   *(volatile unsigned int *)((unsigned int)pSavageXvMCContext->MMIO.address + x) = y

#define INREG(x) *(volatile unsigned int *)((unsigned int)pSavageXvMCContext->MMIO.address + x)

#define ALT_STATUS_WORD0  (* (tmp = (unsigned int *)((unsigned int)pSavageXvMCContext->MMIO.address + STATUS_WORD_0)))

#define GET_EVENT_TAG	  (unsigned short)((*(volatile unsigned int *)((unsigned int)pSavageXvMCContext->MMIO.address + 0x48c06)) & 0xffff)

#define	  xfn_WAIT_FOR_FIFO(x) do {	    \
	  int loop = 0;			    \
	  int slots = MAXFIFO - x;	    \
	  volatile unsigned int * tmp;	    \
	  /*printf("f",x);*/  \
	  while(((ALT_STATUS_WORD0 & 0x001fffff) > slots) && (loop++ < MAXLOOP)); \
	  } while(0)


#define	  xfn_WAIT_FOR_IDLE do {	    \
	  int loop = 0;			    \
	  volatile unsigned int * tmp;	    \
	  /*printf("wait for idle\n");*/    \
	  ALT_STATUS_WORD0;		    \
	  while(((ALT_STATUS_WORD0 & 0x05E00000) != 0x05E00000) && (loop++ < MAXLOOP)); \
	  /*printf("now idle\n");*/	    \
	  } while(0)

#define	  xfn_WAIT_FOR_MC do {		    \
	  int loop = 0;			    \
	  volatile unsigned int * tmp;	    \
	  /*printf("wait for mc\n");*/	    \
	  while(((ALT_STATUS_WORD0 & 0x05200000) != 0x05200000) && (loop++ < MAXLOOP)); \
	  /*printf("now mc ready\n");*/	    \
	  } while(0)

#define	  xfn_BCI(x)	*(volatile unsigned int *)pSavageXvMCContext->BCIBaseAddr = x
#define	  xfn_BCIV(x)	*(volatile float *)pSavageXvMCContext->BCIBaseAddr = x

#define VerticalRetraceWait() \
{ \
	VGAOUT8(vgaCRIndex, 0x17); \
	if (VGAIN8(vgaCRReg) & 0x80) { \
		int i = 0x10000; \
		while (((VGAIN8(vgaIOBase + 0x0a) & 0x08)) == 0x08 && i--) ; \
		i = 0x10000; \
		while ((VGAIN8(vgaIOBase + 0x0a) & 0x08) == 0x00 && i--) ; \
	} \
}

#define EnableIO()   \
	ioperm(0, 1024, 1); \
	iopl(3)

#define DisableIO()	      \
	iopl(0);	      \
	ioperm(0, 1024, 0);

/*This file contains all of the fast rountines using MMX instruction */
void IDCTcopy(int * lpDest,int * lpSrc,int wLength){}

void ConvertUnsignedIDCT16To8(int *pDCTDst, int *pDCTSrc, long lMacro){}

long ConvertZeroBasedSignedIDCT16To8(int *pDCTDst, int *pDCTSrc, long lMacro)
{
    long lResult = 0;
    return lResult;
}

void ConvertNonZeroBasedSignedIDCT16To8(int *pDCTDst, int *pDCTSrc, long lMacro){}

void SignedIDCTcopy(int * lpDest,int * lpSrc,int wLength){}

void SavageStreamsOn(savageXvMCContext * pSavageXvMCContext)
{
    unsigned char jStreamsControl=0;
    unsigned short vgaIOBase, vgaCRIndex, vgaCRReg;


    vgaIOBase = pSavageXvMCContext->IOBase;
    vgaCRIndex = vgaIOBase + 4;
    vgaCRReg = vgaIOBase + 5;

    EnableIO();

    /* Unlock extended registers. */

    VGAOUT16(vgaCRIndex, 0x4838);
    VGAOUT16(vgaCRIndex, 0xa039);
    VGAOUT16(0x3c4, 0x0608);

    VGAOUT8( vgaCRIndex, EXT_MISC_CTRL2 );

    jStreamsControl = VGAIN8( vgaCRReg ) | 0x8c;

    /* Wait for VBLANK. */

    VerticalRetraceWait();

    /* Fire up streams! */

    VGAOUT16( vgaCRIndex, (jStreamsControl << 8) | EXT_MISC_CTRL2 );

    OUTREG( 0x8190, (1<<9) | 0x08 );

    /* Wait for VBLANK. */

    VerticalRetraceWait();

    VGAOUT8( vgaCRIndex, EXT_MISC_CTRL2 );
#ifdef XVMCLOG
    printf("jS=%x\n",VGAIN8(vgaCRReg));
#endif
}

Status MCS3ResetStreams(savageXvMCContext * pSavageXvMCContext)
{
    OUTREG( BLEND_CONTROL, 0x01000000 );
    OUTREG(S_WH, (1 << 16) | 1);
    OUTREG(S_CONTROL, INREG(S_CONTROL) | 0xfff8ffff);
    pSavageXvMCContext->dwFlags &= ~STREAM_ON;
    return Success;
}

Status MCS3BeginPicture( savageXvMCContext * pSavageXvMCContext, LPMCS3BeginData lpBD)
{
    unsigned int * lpSymBuff;
    unsigned int dwFrameDesc;
    unsigned short wWidth, wHeight;

    lpSymBuff = (unsigned int  *)pSavageXvMCContext->lpSymbolBuffer;

    wWidth = (lpBD->width);

#ifdef XVMCLOG
    printf("lpBD->width	 =%d\n",lpBD->width);
#endif

    wHeight = (lpBD->height);

#ifdef XVMCLOG
    printf("lpBD->height =%d\n",lpBD->height);
#endif

    pSavageXvMCContext->wWidth = wWidth;
    pSavageXvMCContext->wHeight = wHeight;
    dwFrameDesc = lpBD->dwFrameDesc;
    dwFrameDesc+=wWidth;

    if( (dwFrameDesc & FRAME_FRAME)==FRAME_FRAME )
	dwFrameDesc+=(((unsigned int)wHeight)<<6);
    else
	dwFrameDesc+=(((unsigned int)wHeight>>1)<<6);

    lpSymBuff[0] = 3;
    lpSymBuff[2] = dwFrameDesc;	 /* fisrt dword is the dword number of the buff*/
				 /* Second is the previous macroblock pointer*/
				 /* Third is the frame desc*/
				 /* Fourth is the Macro Block desc*/
				 /* following is the Motion vector*/

#ifdef XVMCLOG
    printf("dwFrameDesc =%08X\n",dwFrameDesc);
#endif

    pSavageXvMCContext->dwIDCTBuffUsed=0;

    return 1;
}

Status MCS3EndPicture(savageXvMCContext * pSavageXvMCContext)
{
    unsigned int  * lpSymBuff, dwSymPtr;

    lpSymBuff = pSavageXvMCContext->lpSymbolBuffer;
    dwSymPtr = lpSymBuff[0];
    lpSymBuff[dwSymPtr] = 0xffffffff;
    return 1;
}

Status	MCS3MacroBlock(LPMCS3MacroBLKData lpMD, savageXvMCContext * pSavageXvMCContext)
{
    unsigned int  * lpSymBuff;
    unsigned int BuffPtr, dwMacro;
    unsigned int  dwX, dwY, dwOverFlow;
    unsigned  wLength;
    unsigned char * lpIDCT;
    unsigned int  dwFrameDesc, dwWidth, dwHeight,dwMV0, dwMV1,dwMT16X8;


    lpSymBuff = (unsigned int *)pSavageXvMCContext->lpSymbolBuffer;
    BuffPtr = lpSymBuff[0];
    lpSymBuff[1] = BuffPtr;
    dwFrameDesc = lpSymBuff[2];

    dwMacro = lpMD->dwMacroBLKDesc;

    dwMT16X8 = 0;

    dwOverFlow = 0;

    dwWidth = ((pSavageXvMCContext->wWidth-1)<<5) & 0xffff;

    if(pSavageXvMCContext->dwFlags & MB_DUMMY_BLOCK)
	dwWidth-=pSavageXvMCContext->dwDummyTile;

    if( (dwFrameDesc&FRAME_FRAME)==FRAME_FRAME )
	dwHeight = ((pSavageXvMCContext->wHeight - 1) << 5) & 0xffff;
    else
    {
	dwHeight = ((pSavageXvMCContext->wHeight - 2) << 4) & 0xffff;
	if( (dwMacro&MB_MOTION_DP) == MB_MOTION_FRAME )
	    dwMT16X8=16;
    }

#ifdef XVMCLOG
    printf("MacroBlock: dwWidth=%x, dwHeight=%x\n", dwWidth, dwHeight);

    printf("dwMacroDesc=%x\n", dwMacro);
#endif

    dwX = (lpMD->dwMBLKHOff<<1);
    dwY = (lpMD->dwMBLKVOff<<1);

    wLength = 0;


    if( dwMacro & ( MB_DECODE_CrBLK + MB_DECODE_CbBLK +
		    MB_DECODE_Y3BLK + MB_DECODE_Y2BLK +
		    MB_DECODE_Y1BLK + MB_DECODE_Y0BLK ))
    {

	lpIDCT = (unsigned char *)pSavageXvMCContext->lpIDCTBuff+
				  pSavageXvMCContext->dwIDCTBuffUsed;

	dwOverFlow = ( (dwMacro >>16)&(0x3f) );

#ifdef XVMCLOG
	printf("Buf=%x, lpDCT=%x, dwOverflow=%x\n", lpIDCT, lpMD->lpIDCTBuff, dwOverFlow);
#endif

#ifdef XVMCLOG
	     printf("No Overflow\n");
#endif

	    if(dwMacro&MB_DECODE_CrBLK)
		 wLength = 64;

	    if(dwMacro&MB_DECODE_CbBLK)
		 wLength += 64;

	    if(dwMacro&MB_DECODE_Y3BLK)
		 wLength += 64;

	    if(dwMacro&MB_DECODE_Y2BLK)
		 wLength += 64;

	    if(dwMacro&MB_DECODE_Y1BLK)
		 wLength += 64;

	    if(dwMacro&MB_DECODE_Y0BLK)
		 wLength += 64;

	    if(!(dwMacro&MB_IDCT_16BPP))
	    {
		if(!(dwMacro & MB_IDCT_SIGNED))
		{
#ifdef XVMCLOG
		    printf("unsigned \n");
#endif
		    if(lpIDCT != lpMD->lpIDCTBuff)
		    {
#ifdef XVMCLOG
			printf("copy \n");
#endif
			IDCTcopy((int *)lpIDCT,(int *)lpMD->lpIDCTBuff,(int)wLength);
		    }
		}
		else
		{
#ifdef XVMCLOG
		    printf("signed \n");
#endif
		    SignedIDCTcopy((int *)lpIDCT,(int *)lpMD->lpIDCTBuff,(int)wLength);
		}
	    }
	    else
	    {
		if((dwMacro & MB_TYPE_INTER_FB)==MB_TYPE_INTRA)
		{
		    if(!(dwMacro & MB_IDCT_SIGNED))
			ConvertUnsignedIDCT16To8((int *)lpIDCT,(int *)lpMD->lpIDCTBuff, dwMacro);
		    else
		    {
			ConvertNonZeroBasedSignedIDCT16To8((int *)lpIDCT,(int *)lpMD->lpIDCTBuff, dwMacro);
		       /* dwOverFlow = dwMacro & 0x3f;*/
		    }
		}
		else
		{
		     dwMacro = ConvertZeroBasedSignedIDCT16To8((int *)lpIDCT,(int *)lpMD->lpIDCTBuff, dwMacro);
		     /* dwOverFlow = ( (dwMacro >>16)&(0x3f) );*/
		}
	    }
	pSavageXvMCContext->dwIDCTBuffUsed+=wLength;
     }

	 {
	    unsigned long IDCTOffset=pSavageXvMCContext->dwIDCTBuffUsed-wLength;
		     int  i;
#if 0
	   if(pSavageXvMCContext->dwOverFlow)
	   {
	       /* -------------------------------------------------------------------------
		  Set dwOverFlow flag
		  when All Inter-macroblocks in P and B picture.
		----------------------------------------------------------------------- */
	       for(i=0;i<wLength;i++)
	       {
		 *(unsigned char*)(pSavageXvMCContext->DCTBlock[2].offset+(IDCTOffset+i)   )=
		 (unsigned char)((*(short*)(pSavageXvMCContext->DCTBlock[0].offset+(IDCTOffset+i)*2))>>1);
	       }

		 dwOverFlow = dwMacro & 0x0000003f;
	   }
	   else
	   {   /* ------------------Intra MacroBlock------------------------------------- */
	       for(i=0;i<wLength;i++)
	       {
		      *(unsigned char*)(pSavageXvMCContext->DCTBlock[2].offset+(IDCTOffset+i)	)=
		      (unsigned char)(*(short*)(pSavageXvMCContext->DCTBlock[0].offset+(IDCTOffset+i)*2));
	       }
		 dwOverFlow =0;
	   }
#else
	   if(!(pSavageXvMCContext->dwOverFlow & 0x2))
	   {
	       unsigned short * sBuff;
	       unsigned char * cBuff;

	       printf("16-bit IDCT\n");

	       cBuff = (unsigned char *)pSavageXvMCContext->lpIDCTBuff;
	       sBuff = (unsigned short *)pSavageXvMCContext->lpIDCTBuff;
	       cBuff += IDCTOffset;
	       sBuff += IDCTOffset;
	       if(pSavageXvMCContext->dwOverFlow)
	       {
		   /* -------------------------------------------------------------------------
		      Set dwOverFlow flag
		      when All Inter-macroblocks in P and B picture.
		    ----------------------------------------------------------------------- */
		   for(i=0;i<wLength;i++)
		   {
		       cBuff[i] = (unsigned char)(sBuff[i] >> 1);
		   }
		   dwOverFlow = dwMacro & 0x0000003f;
	       }
	       else
	       {   /* ------------------Intra MacroBlock------------------------------------- */
		   for(i=0;i<wLength;i++)
		   {
		      cBuff[i] = (unsigned char)sBuff[i];
		   }
		   dwOverFlow =0;
	       }
	   }
#endif
	 }

#ifdef MACROCMD
    if(dwOverFlow)
	dwMacro = (dwMacro&0x078007ff)+(dwY<<6)+(dwX<<12)+0xd8000000;
    else
	dwMacro = (dwMacro&0x078007ff)+(dwY<<6)+(dwX<<12)+0xd0000000;
#else
    if(dwOverFlow)
	dwMacro = (dwMacro&0x078007ff)+(dwY<<6)+(dwX<<12)+MB_9B_ENABLED;
    else
	dwMacro = (dwMacro&0x078007ff)+(dwY<<6)+(dwX<<12);
#endif

      lpSymBuff[BuffPtr++] = dwMacro;
#if 0
      printf("lpSymBuff[%08X]___dwMacroblockDesc=%08X..........\n",(BuffPtr-1),lpSymBuff[(BuffPtr-1)]);
#endif

  if(dwOverFlow)
  {
	    lpSymBuff[BuffPtr++] = dwOverFlow;

#ifdef XVMCLOG
    printf("lpSymBuff[%08X]___dwOverFlow=%08X..........\n",(BuffPtr-1),lpSymBuff[(BuffPtr-1)]);
#endif

  }

    if(dwMacro&MB_MV0_ENABLED)
    {
	dwMV0=(unsigned int)lpMD->wMV[0];
	dwMV1=(unsigned int)lpMD->wMV[1];

	{
		if(dwMV0 & 0x8000)
			dwMV0 = dwMV0*(-1)+0x800;

		if(dwMV1&0x800)
		{

			if( (dwMV1&0xfff) == 0xe00 )
				dwMV1 = (dwMV1&MV_BOTTOM_REF_FIELD)+
					    0x3ff;
			else
				dwMV1 = (dwMV1&MV_BOTTOM_REF_FIELD)+
		       (dwMV1|0xf000)*(-1)+0x200;
		}

		dwMV0&=0xffff;
		dwMV1&=0xffff;

		if(dwMV0&0x800)
		{
			if( dwX<(dwMV0&0x7ff) )
				dwMV0=0;
		}
		else
		{
			if(dwWidth<(dwMV0+dwX))
				dwMV0=0;
		}

		if(dwMV1&0x200)
		{
			if( dwY<(dwMV1&0x1ff) )
				dwMV1&=0xfc00;
		}
		else
		{
			if(dwHeight<((dwMV1&0x1ff)+dwY))
				dwMV1&=0xfc00;
		}

	    lpSymBuff[BuffPtr++] = dwMV0+(dwMV1<<16);

#ifdef XVMCLOG
	    printf("lpSymBuff[%08X]___MV0=%08X..........\n",(BuffPtr-1),lpSymBuff[(BuffPtr-1)]);
#endif

      }
    }

    if(dwMacro&MB_MV1_ENABLED)
    {
	dwMV0=(unsigned int)lpMD->wMV[2];
	dwMV1=(unsigned int)lpMD->wMV[3];

	{
	    if(dwMV0 & 0x8000)
		dwMV0 = dwMV0*(-1)+0x800;

		if(dwMV1&0x800)
		{

			if( (dwMV1&0xfff) == 0xe00 )
				dwMV1 = (dwMV1&MV_BOTTOM_REF_FIELD)+
					    0x3ff;
			else
				dwMV1 = (dwMV1&MV_BOTTOM_REF_FIELD)+
					    (dwMV1|0xf000)*(-1)+0x200;
		}

		dwMV0&=0xffff;
		dwMV1&=0xffff;

		if(dwMV0&0x800)
		{
			if( dwX<(dwMV0&0x7ff) )
			dwMV0=0;
		}
		else
		{
			if(dwWidth<(dwMV0+dwX))
					dwMV0=0;
		}

		if(dwMV1&0x200)
		{
			if( (dwY+(16&dwMT16X8))<(dwMV1&0x1ff) )
			dwMV1&=0xfc00;
		}
		else
		{
			if(dwHeight<((dwMV1&0x1ff)+dwY+(16&dwMT16X8)))
				dwMV1&=0xfc00;
		}
	}

	lpSymBuff[BuffPtr++] = dwMV0+(dwMV1<<16);

#ifdef XVMCLOG
	printf("lpSymBuff[%08X]___MV1=%08X..........\n",(BuffPtr-1),lpSymBuff[(BuffPtr-1)]);
#endif

    }

    if(dwMacro&MB_MV2_ENABLED)
    {
	dwMV0=(unsigned int)lpMD->wMV[4];
	dwMV1=(unsigned int)lpMD->wMV[5];

     {
	  if(dwMV0 & 0x8000)
	     dwMV0 = dwMV0*(-1)+0x800;

	  if(dwMV1&0x800)
	  {
	     if( (dwMV1&0xfff) == 0xe00 )
		  dwMV1 = (dwMV1&MV_BOTTOM_REF_FIELD)+
			       0x3ff;
		  else
		  dwMV1 = (dwMV1&MV_BOTTOM_REF_FIELD)+
			  (dwMV1|0xf000)*(-1)+0x200;
	  }

	  dwMV0&=0xffff;
	  dwMV1&=0xffff;
	  if(dwMV0&0x800)
	  {
	    if( dwX<(dwMV0&0x7ff) )
	    dwMV0=0;
	  }
	  else
	  {
	    if(dwWidth<(dwMV0+dwX))
	    dwMV0=0;
	  }

	  if(dwMV1&0x200)
	  {
	    if( dwY<(dwMV1&0x1ff) )
		dwMV1&=0xfc00;
	  }
	  else
	  {
	    if(dwHeight<((dwMV1&0x1ff)+dwY))
		dwMV1&=0xfc00;
	   }
	}
	lpSymBuff[BuffPtr++] = dwMV0+(dwMV1<<16);

#ifdef XVMCLOG
	printf("lpSymBuff[%08X]___MV2=%08X..........\n",(BuffPtr-1),lpSymBuff[(BuffPtr-1)]);
#endif

    }

    if(dwMacro&MB_MV3_ENABLED)
    {
	dwMV0=(unsigned int)lpMD->wMV[6];
	dwMV1=(unsigned int)lpMD->wMV[7];

	{
	   if(dwMV0 & 0x8000)
	      dwMV0 = dwMV0*(-1)+0x800;

	   if(dwMV1&0x800)
	   {
		if( (dwMV1&0xfff) == 0xe00 )
			dwMV1 = (dwMV1&MV_BOTTOM_REF_FIELD)+
				    0x3ff;
		else
			dwMV1 = (dwMV1&MV_BOTTOM_REF_FIELD)+
				    (dwMV1|0xf000)*(-1)+0x200;
	   }

	   dwMV0&=0xffff;
	   dwMV1&=0xffff;

	   if(dwMV0&0x800)
	   {
		if( dwX<(dwMV0&0x7ff) )
			dwMV0=0;
	   }
	   else
	   {
		if(dwWidth<(dwMV0+dwX))
			dwMV0=0;
	   }

	   if(dwMV1&0x200)
	   {
		if( (dwY+(16&dwMT16X8))<(dwMV1&0x1ff) )
		dwMV1&=0xfc00;
	   }
	   else
	   {
		if(dwHeight<((dwMV1&0x1ff)+dwY+(16&dwMT16X8)))
		dwMV1&=0xfc00;
	   }
	}

	lpSymBuff[BuffPtr++] = dwMV0+(dwMV1<<16);

#ifdef XVMCLOG
	printf("lpSymBuff[%08X]___MV3=%08X..........\n",(BuffPtr-1),lpSymBuff[(BuffPtr-1)]);
#endif

    }

    lpSymBuff[0] = BuffPtr;

    return 1;
}

void FindIDCTBlock(savageXvMCContext * pSavageXvMCContext, unsigned int * id)
{
    int i;

    *id = 0;
    for(i = 0; i < 4; i++)
    {
	if(pSavageXvMCContext->DCTBlock[i].offset == (unsigned int)pSavageXvMCContext->lpIDCTBuff)
	{
	    *id = i;
	    break;
	}
    }
}

Status MCS3DecodeFrame(savageXvMCContext * pSavageXvMCContext, savageXvMCSurface * Target, savageXvMCSurface * Future,
		       savageXvMCSurface * Past)
{
    unsigned short width, height;
    unsigned int  * lpSymBuff;
    unsigned int dwFrameDesc,dwMacroBlkDesc;
    unsigned int dwMacroDataAddr, dwBlkCnt;
    unsigned int dwOldYBase, dwOldCbBase, dwOldCrBase;
    unsigned int dwNewYBase, dwNewCbBase, dwNewCrBase;
    unsigned int dwCurYBase, dwCurCbBase, dwCurCrBase;
    unsigned int dwTemp, dwOldIndex, dwNewIndex;
    unsigned int dwMemType;
    unsigned int dwCrOffset;
    unsigned int dwCbOffset;
    unsigned int dwSlotCount;
    unsigned int * addr;
    unsigned int id;
    int j;
#ifdef XVMCLOG
    unsigned int draw = 0x10101010;
#endif

    /*xfn_WAIT_FOR_IDLE;*/

#ifdef XVMCLOG
    printf("----------------------------------Start MCS3DecodeFrame----------------------------------\n");
#endif

    dwMemType = 3;   /* Default is AGP */

    width = pSavageXvMCContext->wWidth<<4;
    height = pSavageXvMCContext->wHeight<<4;
    width = (width + 63) & 0xffffffc0;

#ifdef XVMCLOG
    printf("DecodeFrame: width=%d, height=%d\n", width, height);
#endif
    dwSlotCount = INREG(0x48c24);
#ifdef XVMCLOG
    printf("Engine=%x\n", dwSlotCount);
#endif

    dwMacroDataAddr = (unsigned int)((unsigned int)pSavageXvMCContext->lpIDCTBuff - (unsigned int)pSavageXvMCContext->DCTBlocks.address
												+ pSavageXvMCContext->DCTBlocks.handle);
#ifdef XVMCLOG
    printf("dwMacroDataAddr=%08X  \n",dwMacroDataAddr);
    printf("Decode Frame idct buffer=%x\n", pSavageXvMCContext->lpIDCTBuff);
    addr = (unsigned int *)pSavageXvMCContext->lpIDCTBuff;
#endif

    lpSymBuff = (unsigned int *)pSavageXvMCContext->lpSymbolBuffer;

    lpSymBuff+=2;

    dwBlkCnt = pSavageXvMCContext->dwIDCTBuffUsed >> 6;

    dwBlkCnt--;

    dwFrameDesc = *lpSymBuff++;

     dwNewIndex = dwOldIndex = 0;
     dwTemp = pSavageXvMCContext->dwPictureType;


       dwCurYBase = Target->offsets[0]+ pSavageXvMCContext->Surfaces.offset; /*+ pSavageXvMCContext->fb_base*/
       /* dwCurYBase = 0; */

       dwOldYBase =   Past->offsets[0]+ pSavageXvMCContext->Surfaces.offset; /*+ pSavageXvMCContext->fb_base*/
       /* dwOldYBase = 0; */

       dwNewYBase = Future->offsets[0]+ pSavageXvMCContext->Surfaces.offset; /*+ pSavageXvMCContext->fb_base*/
       /* dwNewYBase = 0; */

#ifdef XVMCLOG
    printf("Target->offsets[0]=%x \n ",Target->offsets[0]);
    printf("  Past->offsets[0]=%x \n ",Past->offsets[0]);
    printf("Future->offsets[0]=%x \n ",Future->offsets[0]);
    printf("pSavageXvMCContext->fb_base	       =%x \n",pSavageXvMCContext->fb_base);
    printf("pSavageXvMCContext->Surfaces.offset=%x \n",pSavageXvMCContext->Surfaces.offset);
    printf("curY=%x, oldY=%x, fY=%x\n", dwCurYBase, dwOldYBase, dwNewYBase);
#endif

    dwCurYBase = (dwCurYBase+2047) & 0xfffff800;
    dwOldYBase = (dwOldYBase+2047) & 0xfffff800;
    dwNewYBase = (dwNewYBase+2047) & 0xfffff800;

    dwCbOffset = (width * height + 2047) & 0xfffff800;
    dwCrOffset = (width * height / 4 + 2047) & 0xfffff800;

    dwOldCbBase = dwOldYBase + dwCbOffset;
    dwOldCrBase = dwOldCbBase + dwCrOffset;

    dwCurCbBase = dwCurYBase + dwCbOffset;
    dwCurCrBase = dwCurCbBase + dwCrOffset;

    dwNewCbBase = dwNewYBase + dwCbOffset;
    dwNewCrBase = dwNewCbBase + dwCrOffset;

#ifdef XVMCLOG
    printf("dwCurYBase = %x, dwCurCbBase=%x, dwCurCrBase=%x\n", dwCurYBase, dwCurCbBase, dwCurCrBase);
    for(j = 0; j < (pSavageXvMCContext->wWidth * pSavageXvMCContext->wHeight); j++)
    {
	for(i = 0; i < 64; i++)
	{
	    if((i%4) == 0)
		draw = (draw == 0x10101010?0xebebebeb:0x10101010);

		draw = 0x80808080;
		addr[i+j*96] = draw;
	}


	for(i = 0; i < 16; i++)
	{
	    addr[i+j*96+64] = 0x80808080;
	 }

	for(i = 0; i < 16; i++)
	{
	    {
		if(j%2)
		    addr[i+j*96+64+16] = 0x00000000;
		else
		    addr[i+j*96+64+16] = 0xa0a0a0a0;
	    }
	}
    }
#endif

    FindIDCTBlock(pSavageXvMCContext, &id);
#if 0
    printf("id = %d, oldTag=%x, Tag=%x, EventTag=%x\n", id, pSavageXvMCContext->DCTBlock[id].dwOldTag,
					       pSavageXvMCContext->DCTBlock[id].dwTag,
					       pSavageXvMCContext->usEventTag);

    for(j = 0; j < 4; j++)
	printf("Get Event Tag=%x\n", GET_EVENT_TAG);
#endif
#if 1
    if(pSavageXvMCContext->DCTBlock[id].dwTag != pSavageXvMCContext->DCTBlock[id].dwOldTag)
    {

      struct timeval start,cur;

      gettimeofday(&start,NULL);

      cur = start;

#ifdef XVMCOG
      printf("DecFrame:EventTag: dwTag %d, dwOldTag %d, GET_EVENT_TAG %d, usEventTag %d.\n",
	     pSavageXvMCContext->DCTBlock[id].dwTag,
	     pSavageXvMCContext->DCTBlock[id].dwOldTag,
	     GET_EVENT_TAG,
	     pSavageXvMCContext->usEventTag);
#endif

	if(pSavageXvMCContext->DCTBlock[id].dwTag > pSavageXvMCContext->DCTBlock[id].dwOldTag)
	{
	    if( ((GET_EVENT_TAG)  <  pSavageXvMCContext->DCTBlock[id].dwTag) &&
		((GET_EVENT_TAG) >=  pSavageXvMCContext->DCTBlock[id].dwOldTag) )
	    {
		if( (pSavageXvMCContext->usEventTag >= pSavageXvMCContext->DCTBlock[id].dwTag) ||
		    (pSavageXvMCContext->usEventTag < pSavageXvMCContext->DCTBlock[id].dwOldTag) )
		{
		  int counter=0;
		  while( ((GET_EVENT_TAG) < pSavageXvMCContext->DCTBlock[id].dwTag) &&
			 ((GET_EVENT_TAG) >= pSavageXvMCContext->DCTBlock[id].dwOldTag) &&
			 (cur.tv_usec - start.tv_usec)	< 100000 /* time out limit: 100ms */ )
		    gettimeofday(&cur,NULL);
		  if ( (cur.tv_usec - start.tv_usec) >= 100000 ) printf("EventTag: timed out 1.\n");
		}
	    }
	}
	else
	{
	    if(pSavageXvMCContext->DCTBlock[id].dwTag < pSavageXvMCContext->DCTBlock[id].dwOldTag)
	    {
		if( ((GET_EVENT_TAG) < pSavageXvMCContext->DCTBlock[id].dwTag) ||
		    ((GET_EVENT_TAG) >= pSavageXvMCContext->DCTBlock[id].dwOldTag) )
		{
		  int counter = 0;
		    if( (pSavageXvMCContext->usEventTag >= pSavageXvMCContext->DCTBlock[id].dwTag) &&
			(pSavageXvMCContext->usEventTag < pSavageXvMCContext->DCTBlock[id].dwOldTag) )
		    {
		      while( (((GET_EVENT_TAG) < pSavageXvMCContext->DCTBlock[id].dwTag) ||
			      ((GET_EVENT_TAG) >= pSavageXvMCContext->DCTBlock[id].dwOldTag)) &&
			     (cur.tv_usec - start.tv_usec)  < 100000 /* time out limit: 100ms */ )
			gettimeofday(&cur,NULL);
		      if ( (cur.tv_usec - start.tv_usec) >= 100000 ) printf("EventTag: timed out 2.\n");
		    }
		}
	    }
	}
    }
#endif

#ifdef XVMCOG
    printf("DecFrame: Locking savage.\n");
#endif
    SAVAGE_LOCK(pSavageXvMCContext,0);
#ifdef XVMCOG
    printf("DecFrame: Locked savage.\n");
#endif

    xfn_WAIT_FOR_FIFO(9);
    xfn_BCI(0x0c00e0000);

    /* Set all base address register */
    xfn_BCI(SET_REGISTER + ONE_DW_REG + 0x40000 + BCI_OLD_Y_Cb_BASE);
    xfn_BCI( (dwOldYBase>>11)+(dwOldCbBase<<5) );
    xfn_BCI( (dwOldCrBase>>11)+(dwNewYBase<<5) );
    xfn_BCI( (dwNewCbBase>>11)+(dwNewCrBase<<5) );
    xfn_BCI( (dwCurYBase>>11)+(dwCurCbBase<<5) );
    xfn_BCI( (dwCurCrBase>>11)+(dwFrameDesc&0xf8000000)+((dwFrameDesc&0xfff)<<15) );

#ifdef XVMCLOG
    printf("Number of Macroblocks = %d\n",dwBlkCnt);
#endif

    /* set MEU with the location and size of IDCT data */
    if(dwBlkCnt != -1)
    {
	if(1 /*lpsMCDev->dwCaps & SP_MS1_TYPE*/)
	{
	    dwBlkCnt = ((((dwBlkCnt+1)<<3)-1)<<3);

	    xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_MACROBLOCK_DATA_ADDR );

	    xfn_BCI(dwMacroDataAddr+dwMemType);
	    xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_BLOCK_COUNT);
	    xfn_BCI(dwBlkCnt);
	}
	else
	{
	     xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_MACROBLOCK_DATA_ADDR_PARA);
	     xfn_BCI(dwMacroDataAddr+dwMemType);

	     xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_BLOCK_COUNT_PARA);
	     xfn_BCI(dwBlkCnt);
	}
    }

#if (defined(MACROCMD) && !defined(MS1))
    xfn_WAIT_FOR_FIFO(sData, dwSymLength);
    memcpy((unsigned char*)lpdwBCI,(unsigned char*)lpSymBuff,(dwSymLength<<2));
#else

    /*Start of the symbol buffer*/
    dwMacroBlkDesc = *lpSymBuff;
    lpSymBuff++;

    dwSlotCount = 0;

#if 0
    wEventTagUsed = ++sData->lpS3MobileData->wEventTag;
    sData->lpS3MobileData->wEventTag++;
#endif

    j = 0;
    while(dwMacroBlkDesc != 0xffffffff )
    {
#ifdef XVMCLOG
	for(i = 0; i < 64; i++)
	{
	    printf("DCT Y Addr[%d]=%x\n", i + j * 96, addr[i+j*96]);
	}


	for(i = 0; i < 16; i++)
	{
	    printf("DCT Cb Addr[%d]=%x\n", i + j * 96 + 64, addr[i+j*96+64]);
	 }

	for(i = 0; i < 16; i++)
	{
	    printf("DCT Cr Addr[%d]=%x\n", i + j * 96 + 64 + 16, addr[i+j*96+64+16]);
	}
#endif

	j++;
#ifdef MACROCMD
	xfn_WAIT_FOR_FIFO(8);

#ifdef XVMCLOG
	printf("Wait for FIFO---------------\n");
	printf("dwMacroBlkDesc= %X \n",dwMacroBlkDesc);
#endif

#else
	xfn_WAIT_FOR_FIFO(14);

#ifdef XVMCLOG
	printf("Wait for FIFO---------------\n");
	printf("dwMacroBlkDesc= %X \n",dwMacroBlkDesc);
#endif

#endif

	if(dwMacroBlkDesc & MB_9B_ENABLED)
	{
	    xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_9B_IDCT);
	    xfn_BCI(*lpSymBuff);
	    lpSymBuff++;
	    dwSlotCount-=2;
	}

#ifdef MACROCMD
	xfn_BCI(dwMacroBlkDesc);		    /*kick off macroblock command*/
	dwSlotCount-=2;
	for(dwTemp = 0x04000000; dwTemp !=0x00400000; dwTemp >>= 1)
	{
	    if(dwTemp & dwMacroBlkDesc)
	    {
		xfn_BCI(*lpSymBuff);
		lpSymBuff++;
		dwSlotCount--;
	    }
	}
#else
	if(dwMacroBlkDesc & MB_MV0_ENABLED)
	{
	    xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_MOTION_VECTOR_0);
	    xfn_BCI(*lpSymBuff);
	    lpSymBuff++;
	    dwSlotCount-=2;
	}

	if(dwMacroBlkDesc & MB_MV1_ENABLED)
	{
	    xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_MOTION_VECTOR_1);
	    xfn_BCI(*lpSymBuff);
	    lpSymBuff++;
	    dwSlotCount-=2;
	}

	if(dwMacroBlkDesc & MB_MV2_ENABLED)
	{
	    xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_MOTION_VECTOR_2);
	    xfn_BCI(*lpSymBuff);
	    lpSymBuff++;
	    dwSlotCount-=2;
	}

	if(dwMacroBlkDesc & MB_MV3_ENABLED)
	{
	    xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_MOTION_VECTOR_3);
	    xfn_BCI(*lpSymBuff);
	    lpSymBuff++;
	    dwSlotCount-=2;
	}

	xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_MACROBLOCK_DESC);
	xfn_BCI(dwMacroBlkDesc);		    //kick off macroblock command
	dwSlotCount-=3;
#endif
	dwMacroBlkDesc = *lpSymBuff;
	lpSymBuff++;

     }/*end of while()*/

#endif

     xfn_WAIT_FOR_FIFO(1);
     xfn_BCI(0xC00C0000);


#if 0
     while(1)
     {
	 if(((*(volatile unsigned int *)((unsigned int)pSavageXvMCContext->MMIO.address + STATUS_WORD_0)) & 0x05e00000) != 0x05e00000);
	 else
	    break;
     }
#endif

#if 1
    pSavageXvMCContext->DCTBlock[id].dwOldTag = GET_EVENT_TAG;

    xfn_WAIT_FOR_FIFO(1);
    xfn_BCI(0x98400000 + pSavageXvMCContext->usEventTag++); /*Update shadow status*/
    pSavageXvMCContext->DCTBlock[id].dwTag=(unsigned int)pSavageXvMCContext->usEventTag;
#endif

#ifdef XVMCOG
    printf("DecFrame: Unlocking savage.\n");
#endif
    SAVAGE_UNLOCK(pSavageXvMCContext);
#ifdef XVMCOG
    printf("DecFrame: Unlocked savage.\n");
#endif

#ifdef XVMCLOG
    printf("--------------------------------End MCS3DecodeFrame----------------------------\n");
#endif
    return 1;

}

Status MCS3DisplayFrame(savageXvMCContext * pSavageXvMCContext, savageXvMCSurface * pSavageXvMCSurf)
{
   unsigned int dwDisplay;
   unsigned int dwSrcCrCbStride;
   unsigned int dwSrcDimensions;
   unsigned int dwSrcAddr;
   unsigned int dwSrcCrAddr;
   unsigned int dwSrcCbAddr;

   unsigned int dwCbOffset, dwCrOffset;
   unsigned int dwTextureControl = 0;
   unsigned int dwWidthRatio;
   unsigned int dwHeightRatio;
   unsigned int dwMaxRatio;

   unsigned int dwDestDimensions;
   unsigned int destOffset;
   unsigned short  width,height,srcWidth,srcHeight;
   unsigned short  wSurfWidth;
   unsigned int i;
   SUBPICINFO *lpSubPicInfo = 0;  /* This local structure variable is moved into savageXvMCSbuPIcture, for performance. */
   unsigned int dwSubX, dwSubY, dwSubWidth, dwSubHeight;
   unsigned int dwTexWidth, dwTexHeight, dwTexDesc;
   unsigned int x, y, z,  dwWidthInTile,dwFlipWidthInTile, dwHeightInTile;
   unsigned int dwSubFlag=0;
   unsigned int dwStride, dwDestStride;
   unsigned int tmpWidth, tmpHeight;

   unsigned char * lpAddr;
   unsigned char *  lpTex;
   unsigned int dwMemType;
   unsigned int dwPFMCtrl;
   unsigned int dwScaling = 0;
#ifdef XVMCLOG
   unsigned int * addr;
#endif


   dwMemType = 3;    /* Default is AGP memory */


#ifdef XVMCLOG
   printf("--------------------Start display frame ---------------------------\n");
   printf("Offsets=%x, fb_base=%x, offset=%x\n", pSavageXvMCSurf->offsets[0],
	   pSavageXvMCContext->fb_base, pSavageXvMCContext->Surfaces.offset);
#endif

   dwSrcAddr = (unsigned int)((pSavageXvMCSurf->offsets[0] /*+ pSavageXvMCContext->fb_base*/ + pSavageXvMCContext->Surfaces.offset + 2047) & 0xfffff800);
   wSurfWidth = (unsigned short) (pSavageXvMCSurf->wWidth + 63) & 0xffffffc0;
   srcWidth= (unsigned int) pSavageXvMCSurf->wWidth;
   dwFlipWidthInTile = ((srcWidth+63)&0xffffffc0)>>6;
   srcHeight = (unsigned int) pSavageXvMCSurf->wHeight;

   width = (unsigned int)(pSavageXvMCSurf->destw);
   height = (unsigned int)(pSavageXvMCSurf->desth);
   tmpWidth = (unsigned int)(pSavageXvMCSurf->srcw);
   tmpHeight = (unsigned int)(pSavageXvMCSurf->srch);

   if(width > tmpWidth)
       width = srcWidth;

   if(height > tmpHeight)
       height = srcHeight;

#ifdef XVMCLOG
   printf("srcwidth=%d, srcheight=%d, destwidth=%d, destheight=%d, srcAddr=%x SurfWidth = %d, stride=%d\n",
	   srcWidth, srcHeight, width, height, dwSrcAddr, wSurfWidth, pSavageXvMCContext->dwStride);
#endif

   dwCbOffset = (unsigned int) ((((unsigned int)wSurfWidth * (unsigned int)srcHeight) + 2047) & 0xfffff800);
   dwCrOffset = (unsigned int) (dwCbOffset / 4 + 2047) & 0xfffff800;

#if 0
   addr =(unsigned int *) (pSavageXvMCContext->Surfaces.address + pSavageXvMCSurf->offsets[0]);
   addr = ((unsigned int)addr + 2047) & 0xfffff800;
   for(i = 0; i < 200; i++)
       printf("Y add[%d] = %x\n", i, addr[i]);

   addr =(unsigned int *) (pSavageXvMCContext->Surfaces.address + pSavageXvMCSurf->offsets[0]);
   addr = (unsigned int *)((unsigned int)addr+ dwCbOffset);
   for(i = 0; i < 200; i++)
       printf("Cb add[%d] = %x\n", i, addr[i]);

   addr = (unsigned int *)((unsigned int)addr+ dwCrOffset);
   for(i = 0; i < 200; i++)
       printf("Cr add[%d] = %x\n", i, addr[i]);
#endif

   /* Set Source Cb Address Register*/
   dwSrcCbAddr = dwSrcAddr + dwCbOffset;

   /* Set Source Cr Address Register*/
   dwSrcCrAddr = dwSrcCbAddr + dwCrOffset;

#ifdef XVMCLOG
   printf("dwY=%x, dwCb=%x, dwCr=%x\n", dwSrcAddr, dwSrcCbAddr, dwSrcCrAddr);
#endif
   /* Set Source Dimensions Register */

   dwSrcDimensions = (wSurfWidth>>3) - 1;

   dwPFMCtrl = 0x08200003;
   if (pSavageXvMCSurf->dwDisplayTaskType&DISPLAY_FRAME)
   {

#ifdef XVMCLOG
       printf("Display Frame\n");
#endif

       dwSrcDimensions |= ((srcHeight-1)<<16);
       dwPFMCtrl |= (wSurfWidth<<4)-184;
       dwSrcCrCbStride = ((wSurfWidth<<3)-184);
       dwSrcCrCbStride+=(dwSrcCrCbStride<<16);

       if ( (width<tmpWidth) || (height<tmpHeight) ||
	   (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE))
       {
	   dwScaling = 1;
	   dwDestDimensions = pSavageXvMCContext->dwMixerStride + 0x10000;
       }
       else
       {
	   dwDestDimensions = pSavageXvMCContext->dwStride - 7 + 0x10000;
       }
   }
   else
   {

#ifdef XVMCLOG
       printf("Display Field\n");
#endif
       dwSrcDimensions |= ((srcHeight>>1)-1)<<16;
       dwPFMCtrl |= (wSurfWidth<<4)-176+0x60000000;
       dwSrcCrCbStride = ((wSurfWidth<<3)-176);
       dwSrcCrCbStride+=(dwSrcCrCbStride<<16);
       dwScaling = 1;
       dwDestDimensions = pSavageXvMCContext->dwMixerStride + 0x10000;
   }
   if (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE)
   {
       dwScaling = 1;
       dwDestDimensions = pSavageXvMCContext->dwMixerStride + 0x10000;
   }


       destOffset = pSavageXvMCContext->dwSubPicMixer;

       dwDisplay = pSavageXvMCSurf->dwDisplayTaskType;



       if (!dwScaling)
       {
	   destOffset = pSavageXvMCContext->FlipBuff[pSavageXvMCContext->dwCurBuff];

	   pSavageXvMCContext->dwCurBuff++;
	   if(pSavageXvMCContext->dwCurBuff == MAXFLIPBUFF)
	     pSavageXvMCContext->dwCurBuff = 0;
       }
#ifdef XVMCLOG
       printf("dwSrcDimension=%x, dwDestDimension=%x\n", dwSrcDimensions, dwDestDimensions);
       printf("dwSrcCbcrStride=%x, dwDestStride=%x\n", dwSrcCrCbStride, dwDestStride);
       printf("PFCtrl=%x\n",dwPFMCtrl);
       printf("--------------------Start to program hardware  ---------------------------\n");
#endif
       xfn_WAIT_FOR_FIFO(12); /* Pay attention */
       xfn_BCI(0x0c08e0000);

       xfn_BCI(SET_REGISTER + ONE_DW_REG + 0x60000 + BCI_PFM_SRCADDR);

       if ( dwDisplay==DISPLAY_BOTTOM_FIELD )
       {
	   xfn_BCI(dwSrcAddr+8);
       }
       else
       {
	   xfn_BCI(dwSrcAddr);
       }

#ifdef XVMCLOG
       printf("PFM destOffset = %x\n", destOffset);
#endif
       xfn_BCI(destOffset+0*1024);
#ifdef XVMCLOG
       printf("dwSrcDimensions=%x, dwDestDimensions=%x\n", dwSrcDimensions, dwDestDimensions);
#endif
       xfn_BCI(dwSrcDimensions);
       xfn_BCI(dwDestDimensions);

       if ( dwDisplay==DISPLAY_BOTTOM_FIELD )
       {
	   xfn_BCI(dwSrcCbAddr+8);
	   xfn_BCI(dwSrcCrAddr+8);
       }
       else
       {
	   xfn_BCI(dwSrcCbAddr);
	   xfn_BCI(dwSrcCrAddr);
       }
       xfn_BCI(dwSrcCrCbStride);

       xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_PFM_CONTROL);
       xfn_BCI(dwPFMCtrl);
#ifdef XVMCLOG
       xfn_WAIT_FOR_IDLE;
       addr = (unsigned int *)(destOffset - pSavageXvMCContext->Surfaces.offset + pSavageXvMCContext->Surfaces.address);

       /* Marked by Giga */
	for(i = 0; i < 60; i++)
	   printf("422 addr[%d]=%x\n", i, addr[i]);

#endif

       /*For subpicture*/
       /*Subpicture parameters, need the interface to support them*/
       /*color table and high color table*/
       /* KGy: !!! All pointers, including contex->subpicture is assumed to be valid. */
       if ((pSavageXvMCContext->dwFlags & SUBPIC_ENABLE))
       {
#ifdef XVMCLOG

	   printf("--------------------Subpicture is enabled  ---------------------------\n");
	   printf("Subpicture is enabled\n");
#endif
	   dwSubFlag = 0;

	       lpSubPicInfo = & (pSavageXvMCContext->lpSubpicture->pInfo);

	   if (pSavageXvMCContext->dwFlags & COLORPALETTE_CHANGED)
	   {
	       unsigned int j;
	       unsigned short wColor;
	       unsigned short * lpPalette;
	       int y, u_cb, v_cr;

	       dwSubFlag|=PALETTECHANGED;

	       lpPalette = (unsigned short *)pSavageXvMCContext->SubPicPalette;

	       for (i = 0; i<16; i++)
	       {
		   u_cb = (pSavageXvMCContext->lpSubpicture->palette[1][i]&0xff);
		   v_cr = (pSavageXvMCContext->lpSubpicture->palette[2][i]&0xff);
		   y = (pSavageXvMCContext->lpSubpicture->palette[0][i]&0xff);

		   if (y)
		   {
		      wColor = (( v_cr & 0xf0 ) << 4 ) | (u_cb & 0xf0)	| (y >> 4);
		   }
		   else
		      wColor = 0;

		   for (j = 0; j<256; j+=16)
		   {
		       lpPalette[i+j] = (wColor|((unsigned short)j<<8));
#ifdef XVMCLOG
		       printf("lpPalette[%d]=%x\n", i+j, lpPalette[i+j]);
#endif
		   }
	       }
	       pSavageXvMCContext->dwFlags &= ~COLORPALETTE_CHANGED;
		   }  /* if palette changed */

	   if ((pSavageXvMCContext->dwFlags & SUBPICIMAGE_CHANGED) ||
	      (pSavageXvMCContext->dwFlags & SUBPICAREA_CHANGED))
	   {
	   /* Build the texture for subpicture.
		* This will be blended with the video surface.
			* SP texture and surface texture will be blended (0,0) to (0,0).
			*/
	      /*unsigned int number, destination on surface*/
	      dwSubHeight = (pSavageXvMCContext->lpSubpicture->subh & 0xffff);
	      dwSubWidth = (pSavageXvMCContext->lpSubpicture->subw&0xffff);
	      dwSubX = (pSavageXvMCContext->lpSubpicture->dstx&0xffff);
	      dwSubY = (pSavageXvMCContext->lpSubpicture->dsty&0xffff);

	      dwTexDesc = 0x62000700;

	       if (srcWidth<=64)
	      {
		  dwTexWidth = 64;
		  dwTexDesc|=6;
	      }
	      else if (srcWidth<=128)
	      {
		  dwTexWidth = 128;
		  dwTexDesc|=7;
	      }
	      else if (srcWidth<=256)
	      {
		  dwTexWidth = 256;
		  dwTexDesc|=8;
	      }
	      else if (srcWidth<=512)
	      {
		  dwTexWidth = 512;
		  dwTexDesc|=9;
	      }
	      else
	      {
		  dwTexWidth = 1024;
		  dwTexDesc|=10;
	      }

	      if (srcHeight <= 32)
	      {
		  dwTexHeight = 32;
		  dwTexDesc|=0x50;
	      }
	      else if (srcHeight <= 64)
	      {
		  dwTexHeight = 64;
		  dwTexDesc|=0x60;
	      }
	      else if (srcHeight <= 128)
	      {
		  dwTexHeight = 128;
		  dwTexDesc|=0x70;
	      }
	      else if (srcHeight <= 256)
	      {
		  dwTexHeight = 256;
		  dwTexDesc|=0x80;
	      }
	      else if (srcHeight <= 512)
	      {
		  dwTexHeight = 512;
		  dwTexDesc|=0x90;
	      }
	      else
	      {
		  dwTexHeight = 1024;
		  dwTexDesc|=0xa0;
	      }

	      lpSubPicInfo->dwTexDesc = dwTexDesc;
			  lpSubPicInfo->fDestH = (float)srcHeight;
			  lpSubPicInfo->fDestW = (float)srcWidth;

	      dwStride = 1 << pSavageXvMCContext->lpSubpicture->pitch;
	      dwDestStride = dwTexWidth<<3;

	      dwWidthInTile = ((srcWidth+63)&0xffffffc0)>>6;
	      dwHeightInTile = ((srcHeight+31)&0xffffffe0)>>5;

	      lpAddr = (unsigned char *)((unsigned int)pSavageXvMCContext->lpSubpicture->data + pSavageXvMCContext->lpSubpicture->offsets[0]);
	      lpTex = (unsigned char * )pSavageXvMCContext->SubPicBuff;

	      {
		 unsigned int dwAperture;
		 unsigned int i,j;

#ifdef XVMCLOG
		 printf("SubPicBuffOffset=%x, dwTexWidth=%d, dwDesc=%x\n", pSavageXvMCContext->SubPicBuffOffset, dwTexWidth, dwTexDesc);
		 printf("SubWidth=%d,SubHeight%d\n", dwSubWidth, dwSubHeight);
		 printf("SubX=%d,SubY=%d\n", dwSubX, dwSubY);
#endif
		 dwAperture = pSavageXvMCContext->SubPicBuffOffset >> 5;
		 dwAperture+=(unsigned int) ((dwTexWidth>>6)<<20);
		 dwAperture|=0x40000000;
		 OUTREG(pSavageXvMCContext->dwTiledSurfReg, dwAperture);

		 lpTex = (unsigned char *) (pSavageXvMCContext->fpTargetAperture);

		 {
#ifdef XVMCLOG
		    unsigned short * lpPalette;
		    unsigned char * tmp;
#endif
		     x = dwWidthInTile << 6;

		     y = dwSubX + dwSubWidth;

		     z = x - y;

		     for (i=dwSubY; i; i--)
		     {
			 memset(lpTex, 0, x);
			 lpTex = (unsigned char *) ((char *) lpTex + 0x2000);
		     }

		     lpTex = (unsigned char *)((char *)lpTex + 0x2000);
		     for (i=dwSubHeight; i; i--)
		     {
			 if (dwSubX)
			 {
			     memset(lpTex, 0, dwSubX);
			 }

			 for(j = 0; j < dwSubWidth; j++)
			 {
			     lpTex[j+dwSubX] = lpAddr[j];
#ifdef XVMCLOG
			     printf("i=%d lpText[%d] = %x buff=%x\n", i, j+dwSubX, (unsigned char)lpTex[j+dwSubX], dd);
#endif
			 }

#if 0
			 MMXCopy( ((unsigned char*) lpTex + dwSubX), lpAddr, dwSubWidth);
#endif

			 if (z)
			 {
			     memset(((char *) lpTex + y), 0, z);
			 }


			 lpAddr = ((unsigned char *) lpAddr + dwStride);
			 lpTex = (unsigned char *) ((char *) lpTex + 0x2000);

		     }

		     for (y=dwHeightInTile * 32 - dwSubY - dwSubHeight; y; y--)
		     {
			 memset(lpTex, 0, x);
			 lpTex = (unsigned char *) ((unsigned char *) lpTex + 0x2000);
		     }
		 }
	      }
	      pSavageXvMCContext->dwFlags &= ~(SUBPICAREA_CHANGED | SUBPICIMAGE_CHANGED);
	   }
       }  /* if subpicture enabled */

       if (dwScaling)
       {

	   destOffset = pSavageXvMCContext->FlipBuff[pSavageXvMCContext->dwCurBuff];

	   pSavageXvMCContext->dwCurBuff++;
	   if(pSavageXvMCContext->dwCurBuff == MAXFLIPBUFF)
	     pSavageXvMCContext->dwCurBuff = 0;

#ifdef XVMCLOG
	   printf("-------------------- Downscaling is needed  ---------------------------\n");
#endif

	   xfn_WAIT_FOR_FIFO(55); /*Pay attention*/
	   xfn_BCI(0x0c0090000);
	   xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_DRAW_LOCAL_CONTROL);
	   xfn_BCI(0x04000010);

#ifdef XVMCLOG
	   printf("-------------------- End of set local control  ---------------------------\n");
#endif

	   if (!dwTextureControl)
	   {
	     /* Calculate horizontal and vertical downscaling ratios*/
	     /* (1X, 2X, 3X, 4X, ...) times 16 to handle fractional*/
	     /* ratios better.*/

#ifdef XVMCLOG
	       printf("-------------------- Initialize texture control	height = %d, width=%d ---------------------------\n", height, width);
	       printf("-------------------- Initialize srcheight = %d, srcwidth=%d ---------------------------\n", srcHeight, srcWidth);
#endif

	       dwWidthRatio = ((unsigned int)srcWidth << 4) / (unsigned int)width;

	       if (dwDisplay == DISPLAY_FRAME)
		   dwHeightRatio = ((unsigned int)srcHeight << 4) / (unsigned int)height;
	       else
		   dwHeightRatio = ((unsigned int)srcHeight << 3) / (unsigned int)height;


	       /*Calculate maximum of horizontal and vertical ratios.*/
	       /*This will determine the MIPMap Level Bias to use.*/
	       dwMaxRatio = max(dwWidthRatio, dwHeightRatio);

	       /*If the scaling ratio is between 2X and 4X, use*/
		 /* trilinear filtering.*/
	       if ((dwMaxRatio > 32) && (dwMaxRatio < 64))
	       {
		   /*Use a simple linear formula to calculate*/
		   /*the MIPMap Level Bias.  This formula was found*/
		   /*experimentally, by checking safe and unsave*/
		   /*level bias values for six scale ratios between*/
		   /*2X and 4X.*/
		   dwTextureControl = 26 - dwMaxRatio;

		   /* Shift level bias into position for the Texture*/
		   /* 0 Control register, and mask off extra bits.*/
		   dwTextureControl <<= 3;
		   dwTextureControl &= 0x00000FF8;

		   /* Add in bits for Trilinear, Enable MIPmapping,*/
		   /* and texture address clamping.*/
		   dwTextureControl += 0x00051007;
		   /*printf("Trilinear\n");*/
		}
		else
		{
		   dwTextureControl = 0x00050001;

		   /* Else if the scaling ratio is not between 2X and 4X,*/
		   /* fall back to bilinear filtering.	Above 4X*/
		   /* downscaling, trilinear doesn't help much, and we*/
		   /* may not be able to calculate a "safe" level bias.*/
		}
	   }

	   xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE0_CTRL);
	   xfn_BCI(dwTextureControl);

	   if (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE)
	   {
	       xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE1_CTRL);
	       xfn_BCI(dwTextureControl | 0x200000);
	   }

#ifdef XVMCLOG
	   printf("-------------------- Setup texture address0	---------------------------\n");
#endif

	   xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE0_ADDR);

#ifdef XVMCLOG
	   printf("Texture 0 dwSubPicMixer=%x\n", pSavageXvMCContext->dwSubPicMixer);
#endif

	   xfn_BCI(pSavageXvMCContext->dwSubPicMixer+0*1024);

	   if (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE)
	   {
	       xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE1_ADDR);
	       xfn_BCI(pSavageXvMCContext->SubPicBuffOffset);
	   }

#ifdef XVMCLOG
	   printf("-------------------- Setup texture address1	---------------------------\n");
#endif
	   xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE0_BLEND_CTRL);
	   xfn_BCI(0x00100410);

	   if (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE)
	   {
	       xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE1_BLEND_CTRL);
	       xfn_BCI(0x04802A00);
	       xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE_PALETTE_ADDR);
	       xfn_BCI(pSavageXvMCContext->SubPicPaletteOffset);
	       xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE_TRANSPARENT_COLOR);
	       xfn_BCI(0x0);
	   }

#ifdef XVMCLOG
	   printf("-------------------- Setup texture desc  ---------------------------\n");
#endif
	   if (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE)
	   {
	       xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE_DESC);
	       xfn_BCI(0X67700EAA | ((lpSubPicInfo->dwTexDesc & 0xFF) << 12) | (dwSubFlag & PALETTECHANGED));
	   }
	   else
	   {
	       xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_TEXTURE_DESC);
	       xfn_BCI(0X02000EAA);
	   }
	   xfn_BCI(SET_REGISTER + ONE_DW_REG + 0x20000 + BCI_FOG_CONTROL);
	   xfn_BCI(0x0);
	   xfn_BCI(0x0);
	   xfn_BCI(0x0);
	   xfn_BCI(SET_REGISTER + ONE_DW_REG + 0x20000 + BCI_DEST_CONTROL);
#ifdef XVMCLOG
	   printf("3D destOffset=%x\n", destOffset+dwFlipWidthInTile);
#endif
	   xfn_BCI(dwFlipWidthInTile+((destOffset + 0*1024)>>3));

	   xfn_BCI(0);
	   xfn_BCI(0x07fff7ff);
#ifdef XVMCLOG
	   printf("-------------------- Draw triangle  ---------------------------\n");
#endif

	   if (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE)
	   {
	       xfn_BCI(DRAW_PRIMITIVE+TYPE_TRIANGLE_STRIP+0x3000D);
	   }
	   else
	   {
	       xfn_BCI(DRAW_PRIMITIVE+TYPE_TRIANGLE_STRIP+0x300CD);
	   }

	   {
	       xfn_BCIV((float)(-width));
	       xfn_BCIV((float)(height));
	   }



	   xfn_BCIV(1.0f);

	   xfn_BCIV((float)(-srcWidth) + 0.5f);

	   if (dwDisplay == DISPLAY_TOP_FIELD)
	   {
	       xfn_BCIV((float)(srcHeight >> 1) + 0.5f);
	   }
	   else if (dwDisplay == DISPLAY_BOTTOM_FIELD)
	   {
	       xfn_BCIV((float)(srcHeight >> 1));
	   }
	   else
	   {
	       xfn_BCIV((float)srcHeight + 0.5f);
	   }

	   if (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE)
	   {
	       xfn_BCIV(-lpSubPicInfo->fDestW + 0.5f);
	       xfn_BCIV(lpSubPicInfo->fDestH + 0.5f );
	   }

	   {
	       xfn_BCIV((float)(width));
	       xfn_BCIV((float)(-height));
	   }

	   xfn_BCIV(1.0f);

	   xfn_BCIV((float)srcWidth + 0.5f);

	   if (dwDisplay == DISPLAY_TOP_FIELD)
	   {
	       xfn_BCIV((float)(-(srcHeight >> 1)) + 0.50f  );
	   }
	   else if (dwDisplay == DISPLAY_BOTTOM_FIELD)
	   {
	       xfn_BCIV((float)(-(srcHeight >> 1)));
	   }
	   else
	   {
	       xfn_BCIV((float)(-srcHeight) + 0.5f);
	   }

	   if (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE)
	   {
	       xfn_BCIV(lpSubPicInfo->fDestW + 0.5f);
	       xfn_BCIV(-lpSubPicInfo->fDestH + 0.5f );
	   }

	   {
	       xfn_BCIV((float)(width));
	       xfn_BCIV((float)(height));
	   }

	   xfn_BCIV(1.0f);

	   xfn_BCIV((float)srcWidth + 0.5f);

	   if (dwDisplay == DISPLAY_TOP_FIELD)
	   {
	       xfn_BCIV((float)(srcHeight >> 1) + 0.5f);
	   }
	   else if (dwDisplay == DISPLAY_BOTTOM_FIELD)
	   {
	       xfn_BCIV((float)(srcHeight >> 1));
	   }
	   else
	   {
	       xfn_BCIV((float)srcHeight + 0.5f);
	   }

	   if (pSavageXvMCContext->dwFlags & SUBPIC_ENABLE)
	   {
	       xfn_BCIV(lpSubPicInfo->fDestW + 0.5f);
	       xfn_BCIV(lpSubPicInfo->fDestH + 0.5f);
	   }

       }
       xfn_WAIT_FOR_FIFO(3); /*Pay attention*/
       xfn_BCI(0xC00F0000);

       xfn_BCI(SET_REGISTER + ONE_DW_REG + BCI_S_0);
#ifdef XVMCLOG
       printf("OVerlay destOffset=%x\n", destOffset);
#endif

	{  /* Left_Out */
	  unsigned int xoffset;
	  if ( /*dwScaling : Not accurate.*/ srcWidth>width) {
	    xoffset = (pSavageXvMCContext->Overlay.srcx * pSavageXvMCContext->Overlay.dw)/pSavageXvMCContext->Overlay.sw;
	  } else
	    xoffset = pSavageXvMCContext->Overlay.srcx;

	  xfn_BCI(destOffset + ((xoffset)/64)*2048/*+sData->dwUpdateOverlayFlipOffset*/);
	}

#ifdef XVMCLOG
       addr = (unsigned int *)(destOffset - pSavageXvMCContext->Surfaces.offset + pSavageXvMCContext->Surfaces.address);
       xfn_WAIT_FOR_IDLE;
       /* Marked by Giga */
	for(i = 0; i < 60; i++)
	   printf("4221 addr[%d]=%x\n", i, addr[i]);


    printf("-------------------- End of display frame  ---------------------------\n");
#endif
    return 1;
}


Status MCS3SetupVideoOverlay(savageXvMCContext * pSavageXvMCContext, savageXvMCSurface pSavageSurf)
{
    unsigned int offset;
    unsigned int pitch;
    unsigned int ssControl;
    unsigned short vgaIOBase, vgaCRIndex, vgaCRReg;

#ifdef XVMCLOG
    printf("-----------------Setup overlay-----------------\n");
#endif
    vgaIOBase = pSavageXvMCContext->IOBase;
    vgaCRIndex = vgaIOBase + 4;
    vgaCRReg = vgaIOBase + 5;

    EnableIO();

    if(!(pSavageXvMCContext->dwFlags & STREAM_ON))
    {
	pSavageXvMCContext->dwFlags |= STREAM_ON;
	SavageStreamsOn(pSavageXvMCContext);
    }

    OUTREG(0x8218, 0);

#if 0
    OUTREG(0x8184,0x13000000); /* patch Lindvd auto change colorkey problem : cause overlay region disappear */
#else
    {
      unsigned int color_key = 0;

      color_key = (pSavageXvMCContext->colorkey << 3) & 0xF8L |
	(pSavageXvMCContext->colorkey << 5) & 0xF800L |
	(pSavageXvMCContext->colorkey << 8) & 0xF80000L;

      OUTREG(0x8184,(0x14000000 | color_key));
    }
#endif

    if(pSavageXvMCContext->Overlay.srcWidth >= pSavageXvMCContext->Overlay.destWidth)
	OUTREG(S_HK1K2, 0x8000);
    else
	OUTREG(S_HK1K2, (pSavageXvMCContext->Overlay.srcWidth << 15) /
				pSavageXvMCContext->Overlay.destWidth);

    if(pSavageXvMCContext->Overlay.srcHeight >= pSavageXvMCContext->Overlay.destHeight)
	OUTREG(S_VK1, 0x8000);
    else
	OUTREG(S_VK1, (pSavageXvMCContext->Overlay.srcHeight << 15) /
				pSavageXvMCContext->Overlay.destHeight);
    OUTREG(S_VK2, 0);


    OUTREG(S_XY, (pSavageXvMCContext->Overlay.destx << 16) |
			       pSavageXvMCContext->Overlay.desty);

    OUTREG(S_WH, ((pSavageXvMCContext->Overlay.destWidth - 1)<< 16) |
				     (pSavageXvMCContext->Overlay.destHeight - 1));

    OUTREG(S_VDDA, (pSavageXvMCContext->Overlay.srcHeight - 1) | 0x8000);

    pitch =  ((pSavageXvMCContext->Overlay.srcWidth * 2 + 7) / 8);


    OUTREG(S_STRIDE, (pSavageXvMCContext->TileOffset << 16 | 0x80000000));

    offset = pitch * pSavageXvMCContext->Overlay.srcy + pSavageXvMCContext->Overlay.srcx * 2;

    ssControl = 0;

    ssControl |= (pSavageXvMCContext->Overlay.srcWidth - 1);
    ssControl |= S_YCrCb422;

    OUTREG(S_CONTROL, ssControl);

    /* Set L2 fifo */
    VGAOUT8(vgaCRIndex, 0x92);
    VGAOUT8(vgaCRReg, (pitch >> 8) | 0x80);
    VGAOUT8(vgaCRIndex, 0x93);
    VGAOUT8(vgaCRReg, pitch);

#ifdef XVMCLOG
    printf("-----------------End of Setup overlay-----------------\n");
#endif
    return Success;
}
